# include <stdio.h>
# include <string.h>
# include <curses.h>
# include "proto.c"
# include "menus.c"
# include "data.c"

void dispnum(int i);
void quit();
WINDOW* msgbox(int y1,int x1,int y2,int x2);
void deleteline();
void deleteword();
void deletebuffer();
void openfile();
void deletefile(char *f);
void init();

void dispnum(int i)
{
     if (i == 1)
     {
	mvprintw (3,2,"%s","Lines: ");
     	mvprintw (3,9,"%s","      ");
     	mvprintw (3,9,"%d",lines);
     	mvprintw (3,65,"%s","Col ");
     	mvprintw (3,72,"%s","     ");
     	mvprintw (3,72,"%d",x);
     }
     else
     {
	mvprintw (3,2,"Lines: ");
	mvprintw (3,9,"      ");
	mvprintw (3,9,"%d",lines);
	mvprintw (3,65,"Col: ");
	mvprintw (3,72,"     ");
     	mvprintw (3,72,"%d",x);
     	i = 40 - strlen(fname)/2;
     	mvprintw(3,i-5,"                         ");
	mvprintw(3,i,"%s",fname);
     }
     refresh();
}

void quit()
{
     curs_set(1);
     deletebuffer();
     wclear(stdscr);
     wrefresh(stdscr);
     delwin(stdscr);
     endwin();
     exit(0);
}

WINDOW *msgbox(int y1,int x1,int y2,int x2)
{
    WINDOW *win;
    win = newwin(y1,x1,y2,x2);
    wbkgd (win,COLOR_PAIR(31));
    wattron(win,COLOR_PAIR(16));
    box(win,ACS_VLINE,ACS_HLINE);
    wmove (win,2,1);
    whline(win,ACS_HLINE,x1-2);
    return win;
}

void deleteline()
{
    line *nl,*pl,*tl;
    node *t,*p;

    if (curline == NULL)
    {
	beep();
	return;
    }
    tl = curline;
    pl = curline -> up;
    nl = curline -> down;
    if (!pl && !nl)
    {
	curline = NULL;
	s = NULL;
	topnode = NULL;
    }
    else
    if (pl == NULL && curline == s)
    {
	s = nl;
	nl -> up = NULL;
	curline = nl;
	topnode = nl;
    }
    else
    if (nl == NULL)
    {
	curline -> start = NULL;
	curline -> count = 0;
    }
    else
    {
	pl -> down = nl;
	nl -> up = pl;
	if (curline == topnode)
	    topnode = nl;
	curline = nl;
    }
    x = 1;
    if ((count % max == 0) && count != 0)
    {
	y -= count / max + 1;
	lines -= count/max + 1;
    }
    else
    {
	y -= count / max;
	lines -= count/max;
    }
    count = 1;
    t = tl -> start;
    while (t)
    {
	p = t;
	t = t -> next;
	free (p);
    }
    if (nl)
	free(tl);
    display(1);
}

void deleteword()
{
   node *t,*p;
   int i,j,siz,cnt;
   char *buf,c;
   if ((curline == NULL) || (count > curline -> count))
   {
      beep();
      return;
   }
   t = curline -> start;
   if (!t)
   {
      beep();
      return;
   }
   buf = (char*) malloc (curline -> count);
   if (!buf)
   {
       beep();
       return;
   }
   i = 0;

   while(t)
   {
      buf[i++] = t -> item;
      t = t -> next;
   }

   cnt = 0;
   for (i=count-1;i>0;i--)
   {
      c = buf[i];
      if (c == ' ' || c == '.' || c == ';' || c == ':' || c == ',')
	  break;
      cnt++;
   }

   for (j= count;j< curline -> count;j++)
   {
      c = buf[j];
      if (c == ' ' || c == '.' || c == ';' || c == ':' || c == ',')
	  break;
   }
   siz = j - i;

   cnt++;
   if (i == 0 && j == curline -> count)
   {
       curline -> start = NULL;
   }
   else
   {
       for (;j<curline -> count;j++)
	   buf[i++] = buf[j];
       t = curline -> start;
       j = 0;
       i--;
       while (1)
       {
		t -> item = buf[j++];
		if (!i)
			break;
		t = t -> next;
		i--;
       }
       t -> next = NULL;
   }

   if (curline -> count > max)
   {
      if (count - siz % max == 0)
      {
	  y -= (count - siz)/ max + 1;
	  lines -= (count - siz)/ max + 1;
      }
      else
      {
	  y -= (count / max);
	  lines -= (count / max);
      }
      count = 1;
      x = 1;
   }
   else
   {
      count = count - cnt + 1;
      x = count;
   }
   curline -> count -= siz;
   display(1);
   dispnum(1);
}

void deletebuffer()
{
    line *nl,*pl,*tl;
    node *t,*p;

    tl = s;
    while (tl)
    {
	pl = tl;
	t = pl -> start;
	while (t)
	{
	   p = t;
	   t = t -> next;
	   free(p);
	}
	tl = tl -> down;
	free(pl);
    }
    s = NULL;
    topnode = NULL;
    curline = NULL;
    x = 1;
    count = 1;
    y = ytop;
    lines = 1;
    wmove (textwin,ytop,1);
    wclear(textwin);
    wrefresh(textwin);
    touchwin(stdscr);
    refresh();
    dispnum(1);
}

void openfile()
{
     FILE *fp;
     char c;
     s = NULL;
     count = 1;
     fp = fopen (fname,"r");
     if (fp != NULL)
     {
	 c = getc(fp);
	 while(c != EOF)
	 {
	    insnode(c);
	    count++;
	    if (c == '\n')
	       count=1;
	    c = getc(fp);
	 }
	 display(1);
     }
     dispnum(2);
     curline = s;
     topnode = s;
     lines = 1;
     count = 1;
     x = 1;
     y = ytop;
}

void deletefile(char *f)
{
    WINDOW *w;
    int i;
    i = remove(f);
    
    w = newwin(3,40,9,20);
    wbkgd (w,COLOR_PAIR(31));
    wattron(w,COLOR_PAIR(16));
    box(w,ACS_VLINE,ACS_HLINE);
    wmove (w,1,1);
    curs_set(0);
    if (i == 0)
	wprintw (w,"               REMOVED ");
    else
        waddstr (w,"            Cannot Delete");
    wgetch(w);
    curs_set(1);
    wclear(w);
    wrefresh(w);
    delwin(w);
    touchwin(stdscr);
    refresh();
    display(1);
}

void init()
{
    box(stdscr,ACS_VLINE,ACS_HLINE);
    wmove (stdscr,2,1);
    whline (stdscr,ACS_HLINE,78);
    wmove (stdscr,1,5);
    wattron(stdscr,A_STANDOUT);
    waddch (stdscr,'F');
    wattroff(stdscr,A_STANDOUT);
    waddstr(stdscr,"ile");
    wmove (stdscr,1,28);
    wattron(stdscr,A_STANDOUT);
    waddch (stdscr,'E');
    wattroff(stdscr,A_STANDOUT);
    waddstr(stdscr,"dit");
    wmove (stdscr,1,48);
    waddstr (stdscr,"Se");
    wattron(stdscr,A_STANDOUT);
    waddch (stdscr,'t');
    wattroff(stdscr,A_STANDOUT);
    waddstr(stdscr,"tings");
    wmove (stdscr,1,65);
    wattron(stdscr,A_STANDOUT);
    waddch (stdscr,'H');
    wattroff(stdscr,A_STANDOUT);
    waddstr(stdscr, "elp ");
    wmove (stdscr,3,36);
    wprintw (stdscr,"%s",fname);
    wmove(stdscr,22,1);
    whline(stdscr,ACS_HLINE,78);
    wmove (stdscr,23,3);
    waddstr (stdscr,"   F3  OPEN              F2   SAVE                       F1   HELP");
    touchwin(stdscr);
    refresh();
}

main(int argc,char *argv[])
{
    int i,j;
    chtype c,ch1;
    bool ts;
    if (argc > 2)
    {
       printf (" CANNOT OPEN MORE THAN ONE FILE ");
       exit(0);
    }
    initscr();
    keypad(stdscr,1);
    noecho();
    initialisecol();
    draw_border();
    if (argc == 2)
    {
       strcpy (fname,argv[1]);
       openfile();
    }
    saved = 1;
    ts = 1;
    init();
    text_color();
    max = rightm - leftm + 1;
    textwin = newwin (18,max+2,4,leftm);

    lines = 1;
    x = 1;
    y = ytop;
    dispsflag();
    display(1);
    dispnum(2);
    wmove(textwin,ytop,1);
    wrefresh(textwin);
    count = 1;
    while (1)
    {
	 c = getch();
	 if (c == CTRL_X)
	     fileoption(5);
	 if (c >= 32 && c <= 126)
	 {
		if (curline)
                    if (curline -> count >= max * 18 - 1)
                    {
                        beep();
		        continue;
                    } 
		ts = 1;
		insnode (c);
		count++;
		if (x < max)
		     x++;
		else
		{
		     if (count % max == 2 && count != 2)
		     {
			 x = 2;
			 if (y < ybottom)
			     y++;
			 else
			 {
			     y -= (topnode -> count / max);
			     topnode = topnode -> down;
			 }
			 lines++;
		     }
		}
		if (curline -> count >= max)
		    display(1);
		else
		    display(0);
		dispnum(1);
	 }
	 else
	 {
	      switch(c)
	      {
		    case KEY_UP:
			    if (curline == NULL)
			    {
				 beep();
				 break;
			    }
			    if (y == ytop)
			    {
				 if (topnode)
				 {
				     if (topnode -> up != NULL)
				     {
					 curline = curline -> up;
					 topnode = topnode -> up;
				     }
				     else
				     {
					 beep();
					 break;
			             }	
				 }
				 else
				 {
				     beep();
				     break;
				 }
				 display(1);
				 if ((topnode -> count != 0 ) && (topnode -> count % max == 0))
					y += topnode -> count / max - 1;
				 else
					y += topnode -> count / max;
				 if (curline -> count >= max)
				 {
				     if (curline -> count % max == 0)
					 count = ((curline -> count - 1) / max * max) + 1;
				     else
					 count = (curline -> count / max * max ) + 1;
				 }
				 else
				 {
				     if (count > curline -> count)
					 count = curline -> count + 1;
				 }
			    }
			    else
			    {
				 if (count > max)
				     count -= max;
				 else
				 {
				     if (curline -> up)
					  curline = curline -> up;
				     else
				     {
					  beep();
					  break;
				     }
				     if (curline -> count >= max)
				     {
					 if (curline -> count % max == 0)
					     count = ((curline -> count - 1) / max * max) + 1;
					 else
					     count = (curline -> count / max * max ) + 1;
				     }
				     else
				     {
					 if (count > curline -> count)
					     count = curline -> count + 1;
				     }
				 }
				 y--;
			    }
			    x = count % max;
			    lines--;
			    dispnum(1);
			    break;
		    case KEY_LEFT:
			    if (curline == NULL || count == 1)
			    {
				beep();
				break;
			    }
			    if (x == 1)
			    {
				x = max;
				count--;
				if (y > ytop)
				    y--;
				else
				{
				    if (topnode -> count % max == 0)
					y += topnode -> count / max - 1;
				    else
					y += topnode -> count / max;
				    topnode = topnode -> up;
				    display(1);
				}
				lines--;
			    }
			    else
			    {
				if (count % max == 1 && count != 1)
					count--;
				else
				{
				     x--;
				     count--;
				}
			    }
			    dispnum(1);
			    break;
		    case KEY_RIGHT:
			    if (curline == NULL)
			    {
				beep();
				break;
			    }
			    if (count == curline -> count + 1)
			    {
				beep();
				break;
			    }
			    if (curline -> count % max == 0 && x == max)
			    {
				count++;
				continue;
			    }
			    if (x == max)
			    {
				count ++;
				x = 1;
				if (y < ybottom)
				    y++;
				else
				{
				    if (topnode -> count % max == 0)
					y -= topnode -> count / max - 1;
				    else
					y -= topnode -> count / max;
				    topnode = topnode -> down;
				    display(1);
				}
				lines++;
			    }
			    else
			    {
				count++;
				x++;
			    }
			    dispnum(1);
			    break;
		    case KEY_DOWN:
			    if (curline == NULL)
			    {
				 beep();
				 break;
			    }
			    if (y == ybottom)
			    {
				 if (count + max <= curline -> count)
				      count += max;
				 else
				 {
				     if (curline -> count % max != 0)
					if (((curline -> count / max) != count / max) && curline -> down)
					 {
					     beep();
					     break;
					 }
				      if (curline -> down)
					   curline = curline -> down;
				      else
				      {
					   beep();
					   break;
				      }
				      count = 1;
				      x = 1;
				 }
				 if ((topnode -> count % max == 0) && (topnode -> count != 0))
					y -= topnode -> count / max - 1;
				 else
					y -= topnode -> count / max;
				 topnode = topnode -> down;
				 display(1);
			    }
			    else
			    {
				 if (count + max <= curline -> count)
				      count += max;
				 else
				 {
				     if (curline -> count % max != 0)
					if (((curline -> count / max) != count / max) && curline -> down)
					{
					   y++;
					   lines++;
					}
				     if (curline -> down != NULL)
					   curline = curline -> down;
				     else
				     {
					   beep();
					   break;
				     }
				     if (count >=max || curline -> count < count)
					  count = (curline -> count % max) + 1;
				     x = (count - 1) % max + 1;
				 }
				 y++;
			    }
			    lines++;
			    dispnum(1);
			    break;

		    case '\n':
			    ts = 1;
			    insnode ('\n');
			    if (y == ybottom)
			    {
				if ((topnode -> count % max == 0) && (topnode -> count != 0))
				     y -= topnode -> count / max - 1;
				else
				     y -= topnode -> count / max;
				topnode = topnode -> down;
				display(1);
				if (count % max == 1 && count != 1)
				     y--;
			   }
			   else
			   {
				if (count % max != 1 || count == 1 || ((count %max == 1) && x == max))
					y++;
			   }
			   lines++;
			   x = 1;
			   count = 1;
			   display(1);
			   dispnum(1);
			   break;

		    case KEY_BACKSPACE:
			   ts = 1;
			   backspace();
			   dispnum(1);
			   break;
		    case KEY_DC:
			   ts = 1;
			   delkey();
			   dispnum(1);
			   break;
		    case '\t':
			   ts = 1;
			   for (i=1;i<=TAB_LEN;i++)
			   {
			       insnode (c);
			       count++;
			       if (x < max)
				 x++;
			       else
			       {
				 if (count % max == 2 && count != 2)
				 {
				     x = 2;
				     if (y < ybottom)
					  y++;
				     else
				     {
					  y -= (topnode -> count / max);
					  topnode = topnode -> down;
				     }
				     lines++;
				 }
			       }
			   }
			   if (curline -> count >= max)
			       display(1);
			   else
			       display(0);
			   dispnum(1);
			   saved = 0;
			   dispsflag();
			   break;
		    case CTRL_F:
			   filemenu();
			   break;
		    case CTRL_E:
			   editmenu();
			   break;
		    case CTRL_T:
			   settings();
			   break;
		    case CTRL_H:
			   helpmenu();
			   break;
		    case KEY_F(1):
			   help(3);
			   break;
		    case KEY_F(2):
			   fileoption (2);
			   break;
		    case KEY_F(3):
			   fileoption (1);
			   break;
		    case CTRL_N:
			   fileoption(0);
			   break;
		    case CTRL_W:
			   ts = 1;
			   deleteword();
			   break;
		    case CTRL_Y:
			   ts = 1;
			   deleteline();
			   break;
		    case CTRL_L:
			   ts = 1;
			   insline();
			   break;
		    case KEY_PPAGE:
			   pageup();
			   break;
		    case KEY_NPAGE:
			   pagedown();
			   break;
		    case KEY_HOME:
			   keyhome();
			   break;
		    case KEY_END:
			   keyend();
			   break;
		}
	}
	if (ts)
	{
	    ts = 0;
	    saved = 0;
	    dispsflag();
	}
	wmove (textwin,y,x);
	wrefresh(textwin);
    }
}

