# define CTRL_E 5
# define CTRL_F 6
# define CTRL_H 8
# define CTRL_L 12
# define CTRL_N 14
# define CTRL_T 20
# define CTRL_W 23
# define CTRL_X 24
# define CTRL_Y 25
# define TAB_LEN 8

typedef struct n
{
   char item;       // To store the character
   struct n *next;  // Pointer to next node
} node;

typedef struct l
{
    int count;          // Holds the count of elements present in the line
    struct l *up,*down; // Pointers to up & down lines
    node *start;        // Pointer to the starting node of the line
} line;


line *s = NULL,*topnode = NULL,*curline = NULL;
int x,y,count,lines=1,bordercolor=2,textcolor=1;
bool saved=0,bk=0;
int ytop = 0,ybottom = 17,max = 76,leftm = 5,rightm = 67;
WINDOW *textwin;
char fname[30] = "Untitled";

// Data.c
void insline(); // To insert blank line above the current line
void pageup(); // To move up one page
void pagedown(); // To move one page down
void text_color(); // To set the text colour
void draw_border(); // To draw the border
void initilisecol();// To initialize the color pairs
line *getline(); // To allocate memory for the line pointer
node *getnode(); // To allocate memory for node pointer
void insnode(char c); // Inserts the character c into the buffer(Linked list)
void delkey(); // To delete a character in the current curser position
void backspace(); // Performs the backspace key operation
void display(int flag); // Displays the contents of buffer

// Menus.c
void keyhome(); // To move the curser to the start of the line
void keyend(); // To move to end of line
void help(int y); // To display help
void textcol(int f); // To change text color
int movement(char *s[],int num,int width,int xpos); // To move the highlighted lines in menus
void wordcount(); // To count the number of words,lines & characters
int savefile(int ch); // To save the file with the give option
void dispsflag(); // To display the save flag
void fileoption(int o); // To take the file options
void setmargin(); // To set the Left and Right margins
void search(); // To search the given string
void filemenu(); // To switch according to the option selected in filemenu
void editmenu(); // To switch according to the option selected in editmenu
void settings(); // To switch according to the option selected in settings menu
void helpmenu(); // To switch according to the option selected in helpmenu

// Edit.c
void dispnum(int i); // Display the line number,filename,cloumn number.
void quit(); // Exit the editor
WINDOW* msgbox(int y1,int x1,int y2,int x2); // Create the divided window with a box
void deleteline(); // Delete the current line
void deleteword(); // Delete the current word
void deletebuffer(); // Delete the contents of entire buffer
void openfile(); // To open a file with the name stored in the array fname
void deletefile(char *f); // Delete the given file
void init(); // To initialise the screen
